#include <iostream>
#include <cstring>
#include <cstdio>
#include <vector>
using namespace std;

const int inf = (1<<29);

struct edge
{
	int t, ne;
};

struct indtree
{
    vector<int> it;
    int m;
    void init( int len )
    {
        m = 1;
        while ( m < len )
            m = m * 2;
        it.resize( 2*m+1, -1 );
    }

    void upd( int pos, int v )
    {
        int p = pos+m-1;
        it[p] = v;
        p = p / 2;
        while ( p > 0 )
        {
            if ( it[2*p] == it[2*p+1] )
                it[p] = it[2*p];
            else it[p] = -1;
            p = p / 2;
        }
    }

    int query( int nd, int nl, int nr, int l, int r )
    {
        if ( ( r < nl ) || ( nr < l ) ) return -2;
        if ( ( l <= nl ) && ( nr <= r ) )
        {
            return it[nd];
        }
        int i, j;
        i = query( nd*2, nl, (nl+nr)/2, l, r );
        j = query( nd*2+1, (nl+nr)/2+1, nr, l, r );
        if ( i == -2 ) return j;
        if ( j == -2 ) return i;
        if ( i == j ) return i;
        return -1;
    }

    int query( int l, int r )
    {
        return query( 1, 1, m, l, r );
    }
};

int n, q;
int fed[100020];
edge ed[200020];
//vector<int> g[100020];

int ts[100020];
int dep[100020], par[100020][19];

int lc;
int ce[100020];   //dokade sam napalnil verigata;
int cst[100020];  //koi vrah e starta na veigata;
int cwh[100020];  //v koq veriga e varhat;
int cpos[100020]; //na koq poz. e varhat v negovata veriga;

indtree tr[100020];

void dfs( int v )
{
//    cout << "DF " << v << endl;
    int i, u;
    ts[v] = 1;
    for ( i = fed[v]; i > -1; i = ed[i].ne )
    {
        u = ed[i].t;
        if ( dep[u] == -1 )
        {
            dep[u] = dep[v] + 1;
            par[u][0] = v;
            dfs( u );
            ts[v] = ts[v] + ts[u];
        }
    }
}

int goup( int v, int k )
{
    int l = 17;
    while ( k > 0 )
    {
        while ( (1<<l) > k )
            l--;
        k = k - (1<<l);
        v = par[v][l];
    }
    return v;
}

int lca( int v, int u )
{
    if ( dep[v] < dep[u] )
        swap( v, u );
    if ( dep[v] != dep[u] )
        v = goup( v, dep[v]-dep[u] );
    if ( v == u ) return v;
    int l = 17;
    while ( par[v][0] != par[u][0] )
    {
        while ( par[v][l] == par[u][l] )
            l--;
        v = par[v][l];
        u = par[u][l];
    }
    if ( v == u ) return v;
    return par[v][0];
}

void make_chain( int v, int cc )
{
    if ( cc == -1 )
    {
        lc++;
        cc = lc;
        cst[cc] = v;
    }
    ce[cc]++;
    cpos[v] = ce[cc];
    cwh[v] = cc;

//    cout << "CH " << v << " " << cc << " " << lc << endl;

    int i, u, mx = 0;
    for ( i = fed[v]; i > -1; i = ed[i].ne )
    {
        u = ed[i].t;
        if ( u != par[v][0] )
        {
            if ( ts[u] > ts[mx] ) mx = u;
        }
    }
    if ( mx != 0 ) make_chain( mx, cc );
    for ( i = fed[v]; i > -1; i = ed[i].ne )
    {
        u = ed[i].t;
        if ( ( u != par[v][0] ) && ( u != mx ) )
        {
            make_chain( u, -1 );
        }
    }
}

int query( int v, int anc )
{
    int u, k;
    if ( v == anc ) return tr[ cwh[v] ].query( cpos[v], cpos[v] );
    if ( dep[ cst[ cwh[v] ] ] <= dep[anc] )
    {
        return tr[ cwh[v] ].query( cpos[anc], cpos[v] );
    }
    u = tr[ cwh[v] ].query( 1, cpos[v] );
    k = query( par[ cst[ cwh[v] ] ][0], anc );
    if ( u == k ) return u;
    return -1;
}

int main()
{
    int i, j, k;
    int le = -1;
    int x, y, z, lcd;
    {
        scanf( "%d", &n );
        memset( fed, -1, sizeof( fed ) );
        for ( i = 1; i <= n; i++ )
        {
            scanf( "%d", &j );
            k = i;
            if ( j == -1 ) continue;
            j++;
			le++;
			ed[le].t = k; ed[le].ne = fed[j]; fed[j] = le;

			le++;
			ed[le].t = j; ed[le].ne = fed[k]; fed[k] = le;
        }
        memset( dep, -1, sizeof( dep ) );
        memset( par, -1, sizeof( par ) );
        dep[1] = 1;
        par[1][0] = 0;
        dfs( 1 );

        for ( i = 0; i <= 17; i++ )
            par[0][i] = 0;
        for ( i = 1; i <= 17; i++ )
        {
            for ( j = 1; j <= n; j++ )
            {
                par[j][i] = par[ par[j][i-1] ][i-1];
            }
        }
        memset( ce, 0, sizeof( ce ) );
        ts[0] = -1;
        lc = 0;
        make_chain( 1, -1 );

//        cout << lc << endl;
        for ( i = 1; i <= lc; i++ )
        {
            tr[i].init( ce[i] );
//            cout << "INIT " << i << " " << ce[i] << endl;
        }

        scanf( "%d", &q );
        for ( i = 1; i <= q; i++ )
        {
            scanf( "%d %d %d", &x, &j, &k );
            if ( x == 1 )
            {
                j++;
                tr[ cwh[j] ].upd( cpos[j], k );
//                cout << "SL\n";
            }
            else if ( x == 2 )
            {
                j++; k++;
                lcd = lca( j, k );
                y = query( j, lcd );
                z = query( k, lcd );
                if ( ( y == z ) && ( y != -1 ) )
                    printf( "YES\n" );
                else printf( "NO\n" );
            }
        }
    }
    return 0;
}
